; This file is generated by The Interactive Disassembler (IDA)
; Processor:	    z80
; Target assembler: Table Driven Assembler (TASM) by Speech Technology Inc.
;
;-----------------------------------------------------------------------------
; Reassembling von musik.com
; mehrkanalige Musik-Ausgabe
; ber User-Port PIO1B Bit0, User-Port CTC ZCTO1, Tondbandausgabe (CTC ZCTO0).

; 3 CTC-Kanle sind nicht direkt nutzbar, da ZCTO2 nicht nutzbar ist 
; (ist mit CTC3 gekoppelt und es gibt keinen Anschlu ZCTO3 an einem CTC-Schaltkreis),
; so wird statdessen ZCTO3 indirekt genutzt und per Interrupt ein Impuls am PIO-Port PIO1B Bit0 erzeugt.
;
; ab 1000h steht die Notenliste, jeweils 6 Byte: 
; Zeitkonstante0, Kanalsteuerwort0, Zeitkonstante1, Kanalsteuerwort1, Zeitkonstante3, Kanalsteuerwort3
; Ende mit 0
; Man kann sich die Notenliste als Piano-Rolle vorstellen; fr jeden Zeittakt
; stehen die gerade auszugebenden Notenwerte.
; Tonhhe s. Programmierhandbuch Kapitel 6.2
; mit einen Basic-Programm (z.B. NOTENA) wird die Notenliste erzeugt.
;-----------------------------------------------------------------------------

; 22.07.2007 vp

		cpu	z80

;-----------------------------------------------------------------------------
; 
;-----------------------------------------------------------------------------

INTCTC3		equ	206h			; INTERRUPT-Adresse CTC3
CTC0		equ	80h			; Kassette und Piepser
CTC1		equ	81h			; User-CTC
CTC3		equ	83h			; 
DPIO1B		equ	89h			; PIO1 PortB Daten
SPIO1B		equ	8Bh			; PIO1 PortB Steuerwort

;-----------------------------------------------------------------------------
; 
;-----------------------------------------------------------------------------

		org 	0C00h

		jp	cmd_musik
aMusik:		db 	"MUSIK   "
		db 	0
		db 	0

cmd_musik:	ld	hl, INTMUS		; Interruproutine
		ld	(INTCTC3), hl		; fr CTC3 zuweisen
		
		call	musik8			; Rcksetzen der 3 CTC-Kanle
		
		ld	a, 0CFh			; Steuerwort Bit-Betrieb
		out	(SPIO1B), a		
		ld	a, 0			; alles Ausgnge
		out	(SPIO1B), a

		
		ld	hl, 1000h		; Anfangsadresse Musik
		
		ld	a, 1
		ld	(TON1), a
		ld	(TON2), a
		ld	(TON3), a

		
musik1:		; erste Note
		
		ld	a, (hl)			; Steuerwort
		or	a
		jr	z, musik8		; Ende bei 0
		ld	b, a			; Steuerwort merken

		inc	hl
		ld	a, (TON1)
		cp	(hl)			; Vergleich letzter Ton mit Zeitkonstante = Tonhhe
		jr	z, musik3		; wenn gleich, keine Neuprogrammierung
		
		or	a			; Zeitkonstante = 0?
		jr	z, musik2		; dann kein Ton
		
		ld	a, b
		out	(CTC0), a		; Steuerwort in CTC
musik2:		ld	a, (hl)
		ld	(TON1), a		; Ton merken
		or	a			; TON1 = 0?
		jr	z, musik3		
		out	(CTC0), a		; Tonhhe als Zeitkonstante in CTC

musik3:		; zweite Note

		inc	hl
		ld	a, (hl)
		ld	b, a
		inc	hl
		ld	a, (TON2)
		cp	(hl)
		jr	z, musik5
		or	a
		jr	z, musik4
		ld	a, b
		out	(CTC1), a
musik4:		ld	a, (hl)
		ld	(TON2), a
		or	a
		jr	z, musik5
		out	(CTC1), a

musik5:		; dritte Note

		inc	hl
		ld	a, (hl)
		ld	b, a
		inc	hl
		ld	a, (TON3)
		cp	(hl)
		jr	z, musik7
		or	a
		jr	z, musik6
		ld	a, b
		set	7,a			; enable interrupt
		out	(CTC3), a
musik6:		ld	a, (hl)
		ld	(TON3), a
		or	a
		jr	z, musik7
		out	(CTC3), a


musik7:		inc	hl
		ld	(LISTENADR), hl		; aktuelle Position merken
		
		ld	de, 4000h
		ld	bc, 4E20h		; 4E20h Bytes kopieren
		ldir				; als "Zeitschleife"
		
		ld	hl, (LISTENADR)
		jp	musik1			; und nchsten Ton ausgeben


musik8:		ld	a, 3			; Rcksetzen 
		out	(CTC0), a		; der 3 CTC-Kanle
		out	(CTC1), a
		out	(CTC3), a
		ret				; und Feierabend


;-----------------------------------------------------------------------------
; Interruptroutine: Ausgabe eines Impulses an User-Pio Bit 0 (Anschlu X7:2A)
;-----------------------------------------------------------------------------

INTMUS:         align	2
		push    af			; Interruptroutine
                ld      a, 1
                out     (DPIO1B), a
                ld      a, 0
                out     (DPIO1B), a
                pop     af
                ei
                reti

;-----------------------------------------------------------------------------
; Merkzellen
;-----------------------------------------------------------------------------


TON1:		ds 	1			; letzter Tonwert 1
TON2:		ds 	1			; letzter Tonwert 2
TON3:		ds 	1			; letzter Tonwert 3
LISTENADR:	ds 	2			; aktuelle Musiklistenadresse

		end
